When building llvmCore, pass the SDKROOT and -arch setting to configure.
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
46 # should be installed.
47 INSTALL_LIBLTO="$9"
48
49 # A yes/no parameter that controls whether to cross-build for an ARM host.
50 ARM_HOSTED_BUILD="${10}"
51
52 # A yes/no parameter that controls whether to cross-build for the iOS simulator
53 IOS_SIM_BUILD="${11}"
54
55 # The version number of the submission, e.g. 1007.
56 LLVM_SUBMIT_VERSION="${12}"
57
58 # The subversion number of the submission, e.g. 03.
59 LLVM_SUBMIT_SUBVERSION="${13}"
60
61 # The current working directory is where the build will happen. It may already
62 # contain a partial result of an interrupted build, in which case this script
63 # will continue where it left off.
64 DIR=`pwd`
65
66 DARWIN_VERS=`uname -r | sed 's/\..*//'`
67 echo DARWIN_VERS = $DARWIN_VERS
68
69 ################################################################################
70 # Run the build.
71
72 # Create the source tree we'll actually use to build, deleting
73 # tcl since it doesn't actually build properly in a cross environment
74 # and we don't really need it.
75 SRC_DIR=$DIR/src
76 rm -rf $SRC_DIR || exit 1
77 mkdir $SRC_DIR || exit 1
78 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
79 # We can't use the top-level Makefile as-is.  Remove the soft link:
80 rm $SRC_DIR/Makefile || exit 1
81 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
82 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
83
84 # Build the LLVM tree universal.
85 mkdir -p $DIR/obj-llvm || exit 1
86 cd $DIR/obj-llvm || exit 1
87
88 if [ "$ARM_HOSTED_BUILD" = yes ]; then
89   # The cross-tools' build process expects to find an existing cross toolchain
90   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
91   rm -rf $DIR/bin || exit 1
92   mkdir $DIR/bin || exit 1
93   for prog in ar nm ranlib strip lipo ld as ; do
94     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
95     T=`xcrun -sdk $SDKROOT -find ${prog}`
96     echo '#!/bin/sh' > $P || exit 1
97     echo 'exec '$T' "$@"' >> $P || exit 1
98     chmod a+x $P || exit 1
99   done
100   # Set up the links for clang.
101   for prog in clang clang++ ; do
102     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
103     T=`xcrun -sdk $SDKROOT -find ${prog}`
104     echo '#!/bin/sh' > $P || exit 1
105     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
106     chmod a+x $P || exit 1
107   done
108
109   PATH=$DIR/bin:$PATH
110 fi
111
112 if [ "$ARM_HOSTED_BUILD" = yes ]; then
113   configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
114                   --target=arm-apple-darwin10 --build=i686-apple-darwin10"
115 elif [ "$IOS_SIM_BUILD" = yes ]; then
116   # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
117   configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
118                   --build=i686-apple-darwin10"
119 else
120   configure_opts="--enable-targets=arm,x86"
121 fi
122
123 if [ "$ARM_HOSTED_BUILD" != yes ]; then
124   if [ $SDKROOT ]; then
125     CPPFLAGS="$CPPFLAGS -isysroot $SDKROOT"
126   fi
127   for host in $HOSTS; do
128     CPPFLAGS="$CPPFLAGS -arch $host"
129   done
130 fi
131
132 if [ \! -f Makefile.config ]; then
133   $SRC_DIR/configure --prefix=$DEST_DIR$DEST_ROOT $configure_opts \
134     --enable-assertions=$LLVM_ASSERTIONS \
135     --enable-optimized=$LLVM_OPTIMIZED \
136     --disable-bindings \
137     CPPFLAGS="$CPPFLAGS" \
138     || exit 1
139 fi
140
141 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
142
143 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
144     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
145     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
146     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
147 fi
148
149 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
150     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
151 else
152     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
153 fi
154
155 # Figure out how many make processes to run.
156 SYSCTL=`sysctl -n hw.activecpu`
157 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
158 # Builders can default to 2, since even if they are single processor,
159 # nothing else is running on the machine.
160 if [ -z "$SYSCTL" ]; then
161     SYSCTL=2
162 fi
163 JOBS_FLAG="-j $SYSCTL"
164
165 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
166     UNIVERSAL_SDK_PATH=$SDKROOT \
167     NO_RUNTIME_LIBS=1 \
168     DISABLE_EDIS=1 \
169     REQUIRES_RTTI=1 \
170     DEBUG_SYMBOLS=1 \
171     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
172     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
173     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
174     VERBOSE=1
175
176 if [ $? != 0 ] ; then
177     echo "error: LLVM 'make' failed!"
178     exit 1
179 fi 
180
181 ################################################################################
182 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
183 # $DEST_DIR, with occasional 'lipo' commands.
184
185 cd $DEST_DIR || exit 1
186
187 # Clean out DEST_DIR in case -noclean was passed to buildit.
188 rm -rf * || exit 1
189
190 cd $DIR/obj-llvm || exit 1
191
192 # Install the tree into the destination directory.
193 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
194     NO_RUNTIME_LIBS=1 \
195     DISABLE_EDIS=1 \
196     DEBUG_SYMBOLS=1 \
197     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
198     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
199     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
200
201 if ! test $? == 0 ; then
202     echo "error: LLVM 'make install' failed!"
203     exit 1
204 fi 
205
206 # Install Version.h
207 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
208 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
209     LLVM_MINOR_VERSION=0
210 fi
211 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
212 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
213 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
214
215 # Find the right version of strip to use.
216 STRIP=strip
217 if [ -n "$SDKROOT" ]; then
218   STRIP=`xcrun -sdk $SDKROOT -find strip`
219 fi
220
221 if [ "x$LLVM_DEBUG" != "x1" ]; then
222     # Strip local symbols from llvm libraries.
223     #
224     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
225     # PPC objects!
226     $STRIP -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
227     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
228         $STRIP -Sxl $f
229     done
230 fi
231
232 # Remove .dir files 
233 cd $DEST_DIR$DEST_ROOT
234 rm -f bin/.dir etc/llvm/.dir lib/.dir
235
236 # Remove PPC64 fat slices.
237 cd $DEST_DIR$DEST_ROOT/bin
238 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
239     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
240         -exec lipo -extract ppc -extract i386 {} -output {} \;
241 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
242     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
243         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
244 else
245     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
246         -exec lipo -extract i386 -extract x86_64 {} -output {} \;
247 fi
248
249 # The Hello dylib is an example of how to build a pass.
250 # The BugpointPasses module is only used to test bugpoint.
251 # These unversioned dylibs cause verification failures, so do not install them.
252 # (The wildcards are used to match a "lib" prefix if it is present.)
253 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
254 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
255
256 # Compress manpages
257 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
258 gzip -f $MDIR/*
259
260 ################################################################################
261 # Create SYM_DIR with information required for debugging.
262
263 # Figure out how many make processes to run.
264 SYSCTL=`sysctl -n hw.activecpu`
265
266 # hw.activecpu only available in 10.2.6 and later
267 if [ -z "$SYSCTL" ]; then
268   SYSCTL=`sysctl -n hw.ncpu`
269 fi
270
271 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
272 # can default to 2, since even if they are single processor, nothing else is
273 # running on the machine.
274 if [ -z "$SYSCTL" ]; then
275   SYSCTL=2
276 fi
277
278 cd $SYM_DIR || exit 1
279
280 # Clean out SYM_DIR in case -noclean was passed to buildit.
281 rm -rf * || exit 1
282
283 # Generate .dSYM files
284 find $DEST_DIR -perm -0111 -type f \
285     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
286     -print | xargs -n 1 -P ${SYSCTL} dsymutil
287
288 # Save .dSYM files and .a archives
289 cd $DEST_DIR || exit 1
290 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
291     | cpio -pdml $SYM_DIR || exit 1
292
293 # Save source files.
294 mkdir $SYM_DIR/src || exit 1
295 cd $DIR || exit 1
296 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
297     | cpio -pdml $SYM_DIR/src || exit 1
298
299 ################################################################################
300 # Install and strip libLTO.dylib
301
302 cd $DEST_DIR$DEST_ROOT
303 if [ "$INSTALL_LIBLTO" = "yes" ]; then
304   DT_HOME="$DEST_DIR/Developer/usr"
305   mkdir -p $DT_HOME/lib
306   mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
307
308   # Save a copy of the unstripped dylib
309   mkdir -p $SYM_DIR/Developer/usr/lib
310   cp $DT_HOME/lib/libLTO.dylib $SYM_DIR/Developer/usr/lib/libLTO.dylib
311
312   # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
313   # PPC objects!
314   $STRIP -arch all -Sl $DT_HOME/lib/libLTO.dylib
315
316   if [ "x$DISABLE_USR_LINKS" == "x" ]; then
317     # Add a symlink in /usr/lib for B&I.
318     mkdir -p $DEST_DIR/usr/lib/
319     (cd $DEST_DIR/usr/lib && \
320       ln -s ../../Developer/usr/lib/libLTO.dylib ./libLTO.dylib)
321   fi
322 else
323   rm -f lib/libLTO.dylib
324 fi
325 rm -f lib/libLTO.a lib/libLTO.la
326
327 # Omit lto.h from the result.  Clang will supply.
328 find $DEST_DIR$DEST_ROOT -name lto.h -delete
329
330 ################################################################################
331 # Remove debugging information from DEST_DIR.
332
333 cd $DIR || exit 1
334
335 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
336 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
337
338 # Strip debugging information from files
339 #
340 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
341 # PPC objects!
342 find $DEST_DIR -perm -0111 -type f \
343     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
344     -print | xargs -n 1 -P ${SYSCTL} $STRIP -arch all -Sl
345
346 chgrp -h -R wheel $DEST_DIR
347 chgrp -R wheel $DEST_DIR
348
349 ################################################################################
350 # Remove the docs directory
351
352 rm -rf $DEST_DIR$DEST_ROOT/docs
353
354 ################################################################################
355 # w00t! Done!
356
357 exit 0